/*********************************************************/
/*                      TICBSY.CMD                       */
/*                                                       */
/*      Copyright 1993 by Douglas C. Palmer              */
/*                        FidoNet:  1:387/31             */
/*                        Internet: doug@ephsa.sat.tx.us */
/*      All Right Reserved.                              */
/*                                                       */
/*      This file may be freely distributed as long      */
/*      as no charge is attached to it beyond the        */
/*      actual costs of reproduction.                    */
/*                                                       */
/*                                                       */
/*     This script creates BSY flags in the proper       */
/*     outbound directory for all nodes who will be      */
/*     processed in the pending TIC files.               */
/*                                                       */
/*      It is ZONE stupid at this time.                  */
/*********************************************************/


Inbound ="d:\therock\bink.in"          /*  Your inbound for TIC files */
Tic     ="c:\therock\tick\tic.cfg"     /*  Your TIC.CFG file          */
Hold    ="d:\therock\bink"             /*  Your Hold file for Binkley */

Call RxFuncAdd 'SysLoadFuncs','REXXUTIL','SysLoadFuncs'
Call SysLoadFuncs

Call SysFileTree Inbound'\*.tic', 'tics', 'FO'

if tics.0=0 then
    do
        say "No tic file to process!"
        exit 2
    end

TicCount = tics.0

do i=1 to tics.0

    infile = tics.i
    dataline = LINEIN(infile,1,1)
    AreaName = Right(dataline,Length(DataLine) - 5)
    say 'Area found --> ' AreaName
    Arealist.i = AreaName
    Call Lineout infile

end

if TicCount > 1 then    /*  Sort Area listings  */
    do
        do i=2 to TicCount
                do j = 1 to i - 1
                        if AreaList.i < AreaList.j then
                             do
                                  HoldArea   = AreaList.i
                                  AreaList.i = AreaList.j
                                  AreaList.j = HoldArea
                             end
                end
        end
    end

Unique.1=AreaList.1
UnCount = 1
LastArea=AreaList.1
if TicCount > 1 then
    do
        Say 'Reducing to Unique names.'
        do i=2 to TicCount
                if AreaList.i <> LastArea then
                        do
                             UnCount        = UnCount + 1
                             Unique.UnCount = AreaList.i
                             LastArea       = AreaList.i
                        end
        end
    end

do i=1 to UnCount
    Unique.i=translate(Unique.i, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')
end

say 'Areas to be processed:'

do i= 1 to UnCount
    say Unique.i
end

say 'Locating affected nodes.'

infile   = Tic
dataline = LINEIN(infile)

        /*      Find the next area name. If the AreaName is among the   */
        /*      listed areas (it is in unique.{1..n}) then collect the  */
        /*      listed addresses until the next area is found, or the   */
        /*      file is finished.                                       */

AreaFound = 0
Node.0    = 0
LastRound = 0

do while LastRound < 2

        dataline = translate(dataline, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ', 'abcdefghijklmnopqrstuvwxyz')
        dataline = translate(dataline, '20'x, '09'x)
        do while ((left(dataline,1)=' ') | (left(dataline,1)='09'x)) & (length(dataline) > 1)
                dataline = right(dataline, length(dataline) - 1)  
        end
        if left(dataline,4) = 'AREA' then       /* get area name  */
                do
                        parse value dataline with ThisArea Directory AreaName
                        AreaFound = 0
                        do i=1 to UnCount
                             if Unique.i = AreaName then
                                  AreaFound = 1
                        end

                end
        else
                if AreaFound = 1 then
                do
                        IsAddr=Pos('/',dataline)
                        if IsAddr <> 0 then
                             do
                                  parse value dataline with ThisAddr Passwd Flags
                                  Node.0        = Node.0 + 1
                                  Affected      = Node.0
                                  Node.Affected = ThisAddr
                             end
                end
        dataline=LINEIN(infile)
        if dataline = '' then
                do
                        LastRound = LastRound + 1
                end
end 

Say 'Sorting affected nodes listing.'

if Node.0 > 1 then    /*  Sort Node listings  */
    do
        do i=2 to Node.0
                do j = 1 to i - 1
                        if Node.i < Node.j then
                             do
                                  HoldNode = Node.i
                                  Node.i   = Node.j
                                  Node.j   = HoldNode
                             end
                end
        end
    end

/*      Make Node listing only unique    */

UNode.1  = Node.1
UNodeCnt = 1
LastNode = Node.1
if Node.0 > 1 then
    do
        do i=2 to Node.0
                if Node.i <> LastNode then
                        do
                             UNodeCnt = UNodeCnt + 1
                             UNode.UNodeCnt = Node.i
                             LastNode = Node.i
                        end
        end
    end

Node.0 = UNodeCnt
do i=1 to Node.0
    Node.i = UNode.i
end

/*      Display affected nodes           */

Say 'Affected nodes are:'

if Node.0 > 0 then
    do i=1 to Node.0
        say Node.i
    end
else
    do
        say "No nodes affected!"
    end

Call Lineout infile

                        /*   Check for affected nodes which are      */
                        /*   Already BUSY -- if they exist, then     */
                        /*   abort the command file.                 */

                        /*   If there are affected nodes, create a   */
                        /*   list of affected nodes, then create a   */
                        /*   proper BSY file for each node.          */


if Node.0 > 0 then
    do
        do i=1 to Node.0
                Destination = Node.i
                Split=Pos('/',Destination)
                DestLength=Length(Destination)

                if Split=0 then
                    do
                        say "Improper address format"
                        exit 2
                    end
                else
                    nop

                ZonePos=Pos(':',Destination)

                if ZonePos=0 then
                    do
                        DestZone=1
                        DestAddr=Destination
                    end
                else
                    if ZonePos=1 then
                        do
                                say "Improper address format"
                                exit 3
                        end
                    else
                        do
                                DestZone=Left(Destination, ZonePos - 1)
                                DestAddr=Right(Destination, DestLength - ZonePos)
                        end

                DestNet = Left(DestAddr, Pos('/',DestAddr) - 1)
                DestNode= Right(DestAddr, Length(DestAddr) - Pos('/',DestAddr))
                
                nnnn = D2X(DestNet, 4)
                mmmm = D2X(DestNode, 4)
                
                BSYName = Hold"\"nnnn""mmmm".BSY"
                
                Call SysFileTree BSYName, 'PreEx', 'FO'

                if PreEx.0 <> 0 then
                        do
                             say "ABORT -- Affected Node BSY!"
                             say "RUNNING CLRTICB.CMD!"
                             "@clrticb"
                             exit 5
                        end
                else
                        do
                             Call LINEOUT BSYName,"TIC BSY"
                             Call LINEOUT BSYName
                        end
        end
    end

return

